/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.benutzerverwaltung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="NACHRICHT.UK",
     query="SELECT o FROM Nachricht o WHERE "

                         + "o"
                +".mandant"
                +".nummer"
              +" = ?1"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="NACHRICHT.All",
     query="SELECT o FROM Nachricht o WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="NACHRICHT.CountByUngelesen",
     query="SELECT COUNT(nachricht) FROM Nachricht nachricht LEFT JOIN nachricht.rolles nachrichtRolle WHERE nachricht.mandant=?4 AND ((nachricht.senderkennung <> ?1) AND (nachricht.id > ?2) AND (nachricht.empfaengerGruppeArt = 'ALLE' OR nachrichtRolle.id IN (?3) OR EXISTS(SELECT urspruenglicheNachricht FROM Nachricht urspruenglicheNachricht LEFT JOIN urspruenglicheNachricht.rolles urspruenglicheNachrichtRolle WHERE (urspruenglicheNachricht.id = nachricht.urspruenglicheNachricht.id) AND (urspruenglicheNachricht.senderkennung = ?1 OR urspruenglicheNachricht.empfaengerGruppeArt = 'ALLE' OR urspruenglicheNachrichtRolle.id IN (?3)))))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "NACHRICHT")
// @javax.persistence.IdClass(NachrichtPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Nachricht
extends AbstractNachricht
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Nachricht() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Nachricht(Nachricht original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "nachricht_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Nachricht")
    @javax.persistence.TableGenerator(name = "Nachricht", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Nachricht", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient NachrichtPK pkCache;

  @Override
  public NachrichtPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new NachrichtPK(getId());
    }

    return pkCache;
  }

  public static <E extends Nachricht> java.util.Map<NachrichtPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<NachrichtPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Nachricht> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedEmpfaengerGruppeArt = false;
          hasChangedSenderkennung = false;
          hasChangedText = false;
          hasChangedZeitpunkt = false;
  
      hasChangedMandant = false;
    
          hasChangedRolles = false;
      
          hasChangedNachrichtsByUrspruenglicheNachricht = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "EMPFAENGER_GRUPPE_ART", nullable = NachrichtConstants.EMPFAENGER_GRUPPE_ART_NULLABLE)
    
  protected de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt empfaengerGruppeArt =  de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt.ALLE;

  @javax.persistence.Transient
  protected boolean hasChangedEmpfaengerGruppeArt = false;

  public boolean hasChangedEmpfaengerGruppeArt(){
    return hasChangedEmpfaengerGruppeArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEmpfaengerGruppeArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt wertNachLadenEmpfaengerGruppeArt;
  
  /**
   * 
   *
   * getter for NACHRICHT.EMPFAENGER_GRUPPE_ART
   */
    @Override   public  de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt getEmpfaengerGruppeArt() {
        return empfaengerGruppeArt;
      }

  /**
   * 
   *
   * setter for NACHRICHT.EMPFAENGER_GRUPPE_ART
   *
   * @param empfaengerGruppeArt
   */
  @Override   public void setEmpfaengerGruppeArt( de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt empfaengerGruppeArt) {

       resetTkCache();
                  de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt empfaengerGruppeArtInternal = empfaengerGruppeArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.empfaengerGruppeArt
      , empfaengerGruppeArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEmpfaengerGruppeArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("empfaengerGruppeArt");
      }


             if (!isSeitLadenVeraendertEmpfaengerGruppeArt) {
          isSeitLadenVeraendertEmpfaengerGruppeArt = thisAttributChanged;
         if (isSeitLadenVeraendertEmpfaengerGruppeArt){
           wertNachLadenEmpfaengerGruppeArt=this.empfaengerGruppeArt;
         }
       }
      

       this.empfaengerGruppeArt = empfaengerGruppeArtInternal;

         }

        
      @javax.persistence.Column(name = "SENDER_BENUTZERKENNUNG", nullable = NachrichtConstants.SENDER_BENUTZERKENNUNG_NULLABLE, length=NachrichtConstants.SENDER_BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String senderkennung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSenderkennung = false;

  public boolean hasChangedSenderkennung(){
    return hasChangedSenderkennung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSenderkennung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenSenderkennung;
  
  /**
   * 
   *
   * getter for NACHRICHT.SENDER_BENUTZERKENNUNG
   */
    @Override   public  java.lang.String getSenderkennung() {
        return senderkennung;
      }

  /**
   * 
   *
   * setter for NACHRICHT.SENDER_BENUTZERKENNUNG
   *
   * @param senderkennung
   */
  @Override   public void setSenderkennung( java.lang.String senderkennung) {

       resetTkCache();
                  
                          java.lang.String senderkennungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(senderkennung, NachrichtConstants.SENDER_BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.senderkennung
      , senderkennungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSenderkennung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("senderkennung");
      }


             if (!isSeitLadenVeraendertSenderkennung) {
          isSeitLadenVeraendertSenderkennung = thisAttributChanged;
         if (isSeitLadenVeraendertSenderkennung){
           wertNachLadenSenderkennung=this.senderkennung;
         }
       }
      

       this.senderkennung = senderkennungInternal;

         }

        
      @javax.persistence.Column(name = "TEXT", nullable = NachrichtConstants.TEXT_NULLABLE, length=NachrichtConstants.TEXT_MAX_LENGTH)
        
  protected java.lang.String text =  null;

  @javax.persistence.Transient
  protected boolean hasChangedText = false;

  public boolean hasChangedText(){
    return hasChangedText;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertText = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenText;
  
  /**
   * 
   *
   * getter for NACHRICHT.TEXT
   */
    @Override   public  java.lang.String getText() {
        return text;
      }

  /**
   * 
   *
   * setter for NACHRICHT.TEXT
   *
   * @param text
   */
  @Override   public void setText( java.lang.String text) {

       resetTkCache();
                  
                          java.lang.String textInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(text, NachrichtConstants.TEXT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.text
      , textInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedText |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("text");
      }


             if (!isSeitLadenVeraendertText) {
          isSeitLadenVeraendertText = thisAttributChanged;
         if (isSeitLadenVeraendertText){
           wertNachLadenText=this.text;
         }
       }
      

       this.text = textInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITPUNKT", nullable = NachrichtConstants.ZEITPUNKT_NULLABLE, precision=NachrichtConstants.ZEITPUNKT_PRECISION)
    
  protected java.util.Date zeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitpunkt = false;

  public boolean hasChangedZeitpunkt(){
    return hasChangedZeitpunkt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZeitpunkt = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenZeitpunkt;
  
  /**
   * 
   *
   * getter for NACHRICHT.ZEITPUNKT
   */
    @Override   public  java.util.Date getZeitpunkt() {
              if (zeitpunkt == null){
            return null;
          } else {
                          return zeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for NACHRICHT.ZEITPUNKT
   *
   * @param zeitpunkt
   */
  @Override   public void setZeitpunkt( java.util.Date zeitpunkt) {

       resetTkCache();
                  java.util.Date zeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitpunkt
      , zeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitpunkt");
      }


             if (!isSeitLadenVeraendertZeitpunkt) {
          isSeitLadenVeraendertZeitpunkt = thisAttributChanged;
         if (isSeitLadenVeraendertZeitpunkt){
           wertNachLadenZeitpunkt=this.zeitpunkt;
         }
       }
      

       this.zeitpunkt = zeitpunktInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu UrspruenglicheNachricht
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "URSPRUENGLICHE_NACHRICHT_ID", referencedColumnName="NACHRICHT_ID"))
  protected de.ivu.elect.business.benutzerverwaltung.entity.Nachricht urspruenglicheNachricht;

  /**
   * 
   */
  @Override
  public void setUrspruenglicheNachricht(@javax.annotation.Nullable  de.ivu.elect.business.benutzerverwaltung.entity.Nachricht urspruenglicheNachricht){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

            de.ivu.elect.business.benutzerverwaltung.entity.Nachricht alterWert = getUrspruenglicheNachricht();
    preSetUrspruenglicheNachricht(alterWert, urspruenglicheNachricht);
    

        if (urspruenglicheNachricht == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.urspruenglicheNachricht != null){
            this.urspruenglicheNachricht.removeNachrichtByUrspruenglicheNachricht(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          urspruenglicheNachricht.addNachrichtByUrspruenglicheNachricht(this);
        }
        this.urspruenglicheNachricht = urspruenglicheNachricht;
        postSetUrspruenglicheNachricht(alterWert, urspruenglicheNachricht);
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setUrspruenglicheNachrichtOhneUpdateBeziehung(@javax.annotation.Nullable  de.ivu.elect.business.benutzerverwaltung.entity.Nachricht urspruenglicheNachricht){
    resetTkCache();
            de.ivu.elect.business.benutzerverwaltung.entity.Nachricht alterWert = getUrspruenglicheNachricht();
    preSetUrspruenglicheNachricht(alterWert, urspruenglicheNachricht);
        this.urspruenglicheNachricht = urspruenglicheNachricht;
        postSetUrspruenglicheNachricht(alterWert, urspruenglicheNachricht);
    }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.benutzerverwaltung.entity.Nachricht getUrspruenglicheNachricht(){
    return this.urspruenglicheNachricht;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu NachrichtsByUrspruenglicheNachricht
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.benutzerverwaltung.entity.Nachricht.class, mappedBy="urspruenglicheNachricht", fetch=javax.persistence.FetchType.LAZY )
// deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht> nachrichtsByUrspruenglicheNachricht;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht> getNachrichtsByUrspruenglicheNachricht(){
    if (nachrichtsByUrspruenglicheNachricht == null){
      return  java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht>unmodifiableSet(this.nachrichtsByUrspruenglicheNachricht);
  }

  @javax.persistence.Transient
  private boolean hasChangedNachrichtsByUrspruenglicheNachricht = false;

  public boolean hasChangedNachrichtsByUrspruenglicheNachricht() {
    return hasChangedNachrichtsByUrspruenglicheNachricht;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.benutzerverwaltung.entity.Nachricht
   */
  @Override
  public void addNachrichtByUrspruenglicheNachricht(de.ivu.elect.business.benutzerverwaltung.entity.Nachricht nachrichtByUrspruenglicheNachricht){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (nachrichtByUrspruenglicheNachricht != null){
          if (this.nachrichtsByUrspruenglicheNachricht == null) {
            this.nachrichtsByUrspruenglicheNachricht = new java.util.HashSet<>();
          }

          boolean isChanged = this.nachrichtsByUrspruenglicheNachricht.add(nachrichtByUrspruenglicheNachricht);

          if(!hasChangedNachrichtsByUrspruenglicheNachricht) {
            hasChangedNachrichtsByUrspruenglicheNachricht =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          nachrichtByUrspruenglicheNachricht.setUrspruenglicheNachricht(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.benutzerverwaltung.entity.Nachricht
   */
  @Override
  public void removeNachrichtByUrspruenglicheNachricht(de.ivu.elect.business.benutzerverwaltung.entity.Nachricht nachrichtByUrspruenglicheNachricht){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (nachrichtByUrspruenglicheNachricht != null){
          if (this.nachrichtsByUrspruenglicheNachricht != null) {
            boolean isChanged = this.nachrichtsByUrspruenglicheNachricht.remove(nachrichtByUrspruenglicheNachricht);

            if(!hasChangedNachrichtsByUrspruenglicheNachricht) {
              hasChangedNachrichtsByUrspruenglicheNachricht =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          nachrichtByUrspruenglicheNachricht.setUrspruenglicheNachricht(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.benutzerverwaltung.entity.Nachricht
  */
   @Override
   public void removeAllNachrichtByUrspruenglicheNachrichts(){
     java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht> toRemove = new java.util.HashSet<>(getNachrichtsByUrspruenglicheNachricht());

     for (   de.ivu.elect.business.benutzerverwaltung.entity.Nachricht entity:toRemove){
       removeNachrichtByUrspruenglicheNachricht(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */
  /**
   * Beziehung N:M (bidirektional, fuehrend) zu Rolles
   */
  @javax.persistence.ManyToMany(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.JoinTable(name="EMPFAENGER_ROLLE",
     joinColumns = {@javax.persistence.JoinColumn(name="NACHRICHT_ID", referencedColumnName="nachricht_id")},
     inverseJoinColumns = {@javax.persistence.JoinColumn(name="ROLLE_ID", referencedColumnName="ROLLE_ID")}) 
// deaktiviert, gibt Probleme beim Löschen   @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Rolle> rolles;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Rolle> getRolles(){
    if (rolles == null){
      return  java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Rolle>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Rolle>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Rolle>unmodifiableSet(this.rolles);
  }


  @javax.persistence.Transient
  private boolean hasChangedRolles = false;

  public boolean hasChangedRolles() {
    return hasChangedRolles;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.benutzerverwaltung.entity.Rolle
  */
  @Override
  public void addRolle(de.ivu.elect.business.benutzerverwaltung.entity.Rolle rolle){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (rolle != null){
          if (this.rolles == null){
            this.rolles = new java.util.HashSet<>();
          }

          boolean isChanged = this.rolles.add(rolle);

          if(!hasChangedRolles) {
            hasChangedRolles =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          rolle.addNachricht(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.benutzerverwaltung.entity.Rolle
   */
  @Override
  public void removeRolle(de.ivu.elect.business.benutzerverwaltung.entity.Rolle rolle){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (rolle != null){
          if (this.rolles != null){
            boolean isChanged = this.rolles.remove(rolle);

            if(!hasChangedRolles) {
              hasChangedRolles =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (rolle != null) {
            rolle.removeNachricht(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.benutzerverwaltung.entity.Rolle
  */
   @Override
   public void removeAllRolles(){
     java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Rolle> toRemove = new java.util.HashSet<>(getRolles());

     for (   de.ivu.elect.business.benutzerverwaltung.entity.Rolle entity:toRemove){
       removeRolle(entity);
     }
   }


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Nachricht:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Nachricht other){
                             other.empfaengerGruppeArt = this.empfaengerGruppeArt;
                                other.senderkennung = this.senderkennung;
                                other.text = this.text;
                                other.zeitpunkt = this.zeitpunkt;
           
  other.setMandant(this.getMandant());
  other.setUrspruenglicheNachricht(this.getUrspruenglicheNachricht());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Nachricht.class)){
        copyEntityAttributesUsingSetter((Nachricht) other.castTo(Nachricht.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Nachricht: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Nachricht other){
               other.setEmpfaengerGruppeArt(this.empfaengerGruppeArt);
                  other.setSenderkennung(this.senderkennung);
                  other.setText(this.text);
                  other.setZeitpunkt(this.zeitpunkt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Nachricht other){
                       if (hasChangedEmpfaengerGruppeArt) {
        other.setEmpfaengerGruppeArt(this.empfaengerGruppeArt);
      }
                             if (hasChangedSenderkennung) {
        other.setSenderkennung(this.senderkennung);
      }
                             if (hasChangedText) {
        other.setText(this.text);
      }
                             if (hasChangedZeitpunkt) {
        other.setZeitpunkt(this.zeitpunkt);
      }
             }





    @javax.persistence.Transient
    private transient NachrichtTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public NachrichtTK getNachrichtTK(){
    if (tkCache==null) {
    tkCache = new NachrichtTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getNachrichtTK();
    }

  @Override
  public NachrichtUK getUk(){
    return getNachrichtUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Nachricht.class;
  }

public NachrichtUK getNachrichtUK(){

   return  new NachrichtUK(

    getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient NachrichtProperties properties;

  public NachrichtProperties getProperties(){
    if (properties == null) {
      properties = new NachrichtProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public NachrichtProperties getNachrichtProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return NachrichtConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(NachrichtConstants.MESSAGE_KEY_EMPFAENGER_GRUPPE_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NachrichtConstants.MESSAGE_KEY_EMPFAENGER_GRUPPE_ART_EINZAHL);

        empfaengerGruppeArt =
     (de.ivu.elect.business.benutzerverwaltung.entity.NachrichtEmpfaengerGruppeArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(NachrichtConstants.MESSAGE_KEY_SENDER_BENUTZERKENNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NachrichtConstants.MESSAGE_KEY_SENDER_BENUTZERKENNUNG_EINZAHL);

        senderkennung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(NachrichtConstants.MESSAGE_KEY_TEXT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NachrichtConstants.MESSAGE_KEY_TEXT_EINZAHL);

        text =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(NachrichtConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NachrichtConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL);

        zeitpunkt =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertEmpfaengerGruppeArt) {
      result.put(NachrichtConstants.MESSAGE_KEY_EMPFAENGER_GRUPPE_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenEmpfaengerGruppeArt , empfaengerGruppeArt));
    }
                            if (isSeitLadenVeraendertSenderkennung) {
      result.put(NachrichtConstants.MESSAGE_KEY_SENDER_BENUTZERKENNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenSenderkennung , senderkennung));
    }
                            if (isSeitLadenVeraendertText) {
      result.put(NachrichtConstants.MESSAGE_KEY_TEXT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenText , text));
    }
                            if (isSeitLadenVeraendertZeitpunkt) {
      result.put(NachrichtConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenZeitpunkt , zeitpunkt));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertEmpfaengerGruppeArt = false;
      wertNachLadenEmpfaengerGruppeArt = null;
                          isSeitLadenVeraendertSenderkennung = false;
      wertNachLadenSenderkennung = null;
                          isSeitLadenVeraendertText = false;
      wertNachLadenText = null;
                          isSeitLadenVeraendertZeitpunkt = false;
      wertNachLadenZeitpunkt = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "NACHRICHT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Nachricht";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(empfaengerGruppeArt, this, NachrichtConstants.MESSAGE_KEY_EMPFAENGER_GRUPPE_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(senderkennung, this, NachrichtConstants.MESSAGE_KEY_SENDER_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(NachrichtConstants.SENDER_BENUTZERKENNUNG_MAX_LENGTH , 1 ,  senderkennung, this, NachrichtConstants.MESSAGE_KEY_SENDER_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(text, this, NachrichtConstants.MESSAGE_KEY_TEXT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(NachrichtConstants.TEXT_MAX_LENGTH , 1 ,  text, this, NachrichtConstants.MESSAGE_KEY_TEXT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeitpunkt, this, NachrichtConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
